
try:
  import psyco
  psyco.full()
except:
  print "No psyco, oh well"

import constants
import data
import pygame
pygame.init()
screen = pygame.display.set_mode((constants.screen_width,constants.screen_height),pygame.constants.SWSURFACE)

import manager



class player_info:
  def __init__(self):
    self.money = 300
    self.score = 0

def init_levels(playa):
  return [
          ("Wave 1!",manager.GameEnv(screen, data.filepath('tilemap.png'), data.filepath('lv1.tga'), (15,15), playa, total=30, quota=10, spawn_rate=20)),
          ("Wave 2!",manager.GameEnv(screen, data.filepath('tilemap.png'), data.filepath('lv1.tga'), (15,15), playa, total=120, quota=80, spawn_rate=10)),
          ("Wave 3!",manager.GameEnv(screen, data.filepath('tilemap.png'), data.filepath('lv1.tga'), (15,15), playa, total=200, quota=150, spawn_rate=5)),
          ("Wave X!",manager.GameEnv(screen, data.filepath('tilemap.png'), data.filepath('lvx.tga'), (15,15), playa, total=200, quota=150, spawn_rate=3, health = 150)),
          ]

def main():
  pygame.mixer.init()
  pygame.font.init()
  
  TitleScreen = manager.TitleScreen()
  eng = TitleScreen
  state = 'title'
  quit = False
  clock = pygame.time.Clock()


  #pygame.mixer.music.load(data.filepath('bgm1.mp3'))
  #pygame.mixer.music.set_volume(0.25)
  #pygame.mixer.music.play()

  
  while not quit:
    events = []
    for e in pygame.event.get():
      events.append(e)
      if e.type is pygame.QUIT: quit = 1
      if e.type is pygame.KEYDOWN and e.key == pygame.K_ESCAPE: quit = 1

    new_state = eng.update(events)

    if new_state:
      if eng.__class__ is manager.TitleScreen:
        #spawn level 1
        playa = player_info()
        levels = init_levels(playa)
        wave, lv = levels.pop(0)
        
        eng = manager.Bumper(wave, 120, next = lv)
        
      elif eng.__class__ is manager.GameEnv:
        if eng.endstate == "Lose":
          wave = "GAME OVER!"
          eng = manager.Bumper(wave, 120, next = manager.TitleScreen())
        else:
          try:
            wave, lv = levels.pop(0)
          except:
            wave = "You Win!"
            lv = manager.TitleScreen()
            
          eng = manager.Bumper(wave, 120, next = lv)

      elif eng.__class__ is manager.Bumper:
        eng = eng.next

    eng.render(screen)
    pygame.display.flip()
    clock.tick(45)
    pygame.display.set_caption("Disco Epidemic! FPS: %03f"% clock.get_fps())

