from pgu import vid
import vector
import images
import data
from pygame import mixer
mixer.init()
boom = mixer.Sound(data.filepath('boom.ogg'))
conv = mixer.Sound(data.filepath('convert.ogg'))

class MySprite(vid.Sprite):
  ishapes = []
  def __init__(self, pos):
    vid.Sprite.__init__(self, self.ishapes[0], pos)
    self.ticks = 0

  def update(self, game_ctx):
    self.ticks += 1
    return True

class FlowSprite(MySprite):
  vel_limit = 0.03
  damp = 0.9
  wall_dist = 0.1
  wall_nudge = 0.07
  low_vel = 0.05
  boogie_accel = 0.03
  low_vel_nudge = 0.12
  def __init__(self, pos):
    MySprite.__init__(self, pos)
    self.vel = (0,0)
    self.travels = []
  def update(self, game_ctx):
    MySprite.update(self, game_ctx)
    grad = game_ctx.discopot.get_grad(self.pos)
    if game_ctx.discopot.is_wall(self.pos):
      return False # we're in a wall. fuck it
    if game_ctx.discopot.is_wall(vector.addvec(self.pos, (-self.wall_dist, 0))):
      self.vel = self.vel[0] * -1, self.vel[1]
      self.vel = vector.addvec(self.vel, (self.wall_nudge, 0))
    if game_ctx.discopot.is_wall(vector.addvec(self.pos, (self.wall_dist, 0))):
      self.vel = self.vel[0] * -1, self.vel[1]
      self.vel = vector.addvec(self.vel, (-self.wall_nudge, 0))
    if game_ctx.discopot.is_wall(vector.addvec(self.pos, ( 0, -self.wall_dist))):
      self.vel = self.vel[0] , self.vel[1] * -1
      self.vel = vector.addvec(self.vel, ( 0, self.wall_nudge,))
    if game_ctx.discopot.is_wall(vector.addvec(self.pos, (0, self.wall_dist))):
      self.vel = self.vel[0] , self.vel[1] * -1
      self.vel = vector.addvec(self.vel, ( 0, -self.wall_nudge,))
    dir = vector.normalize(grad)
    self.vel = vector.addvec(self.vel, vector.mul(grad, self.boogie_accel))
    if vector.vmag(self.vel) < self.low_vel:
      self.vel = vector.mul(dir, self.low_vel_nudge)
    self.vel = vector.mul(self.vel, self.damp)
    self.pos = vector.addvec(self.pos, self.vel)
    self.travels.append(self.vel)
    self.travels = self.travels[-190:]
    if len(self.travels) > 160:
      tdist = reduce(vector.addvec, self.travels)
      if vector.vmag(tdist) < 0.9:
        boom.play()
        return False # we're stuck. fuck it.
      
    return True

class Disco(FlowSprite):
  ishapes = images.disco

  def __init__(self, pos, health = 30, worth=25):
    FlowSprite.__init__(self, pos)
    self.health = health
    self.worth = worth

  def update(self, game_ctx):
    ret = FlowSprite.update(self, game_ctx)
    if (int(self.pos[0]), int(self.pos[1])) in game_ctx.discopot.negset:
        return False
    return ret

class Square(FlowSprite):
  ishapes = images.square
  boogie_accel = -0.08 #boogie against the flow yo
  low_vel_nudge = -0.09
  def __init__(self, pos):
    FlowSprite.__init__(self, pos)

  def update(self, game_ctx):
    ret = FlowSprite.update(self, game_ctx)
    if vector.vfloor(self.pos) in game_ctx.discopot.posset:
        return False
    return ret

class Pylon(MySprite):
  ishapes = images.pylon
  def __init__(self, pos):
    MySprite.__init__(self, pos)

class Boomtower(MySprite):
  ishapes = images.boomer
  def __init__(self, pos, strength, range):
    MySprite.__init__(self, pos)
    self.strength = strength
    self.range = range
  
  def update(self, game_ctx):
    for spr in game_ctx.iso_eng.sprites:
      if spr.__class__ is Disco:
        dist = vector.vmag(vector.subvec(self.pos, spr.pos))
        if dist < self.range:
          spr.health -= self.strength
        if spr.health <= 0:
          game_ctx.iso_eng.sprites.remove(spr)
          game_ctx.defunked += 1
          game_ctx.player_info.money += spr.worth
          game_ctx.iso_eng.sprites.append(Square(spr.pos))
          conv.play()
    return True

